package scylladb

import (
	"clickandjoin.app/websocketserver/modules/config"
	"github.com/gocql/gocql"
	"github.com/scylladb/gocqlx/v2"
	"github.com/sirupsen/logrus"
)

var Session gocqlx.Session
var Cluster *gocql.ClusterConfig

func InitDatabase() {
	Cluster = gocql.NewCluster(config.Cfg.ScyllaDB.Host)

	Cluster.Authenticator = gocql.PasswordAuthenticator{
		Username: config.Cfg.ScyllaDB.Username,
		Password: config.Cfg.ScyllaDB.Password,
	}

	Cluster.Keyspace = config.Cfg.ScyllaDB.Keyspace

	var err error

	Session, err = gocqlx.WrapSession(Cluster.CreateSession())

	if err != nil {
		logrus.Fatal(err)
	}

	logrus.Info("Database connected")
}
