package utils

import (
	"encoding/json"

	"clickandjoin.app/websocketserver/modules/structs"
	"github.com/sirupsen/logrus"
)

func MarshalMessage(message any) (marshaledMessage []byte, err error) {
	marshaledMessage, err = json.Marshal(message)

	if err != nil {
		logrus.Errorln("Failed to marshal send message, err:", err)
		return nil, err
	}

	return marshaledMessage, nil
}

func UnmarshalReceivedMessage(body []byte, receivedMessage *structs.ReceivedMessage) error {
	err := json.Unmarshal(body, &receivedMessage)

	if err != nil {
		logrus.Errorln("Failed to unmarshal received message, err:", err)
		return err
	}

	return nil
}
